#ifndef ETI660_H
#define ETI660_H

#include "cdp1802.h"
#include "pixie.h"

class Eti : public Cdp1802, public Pixie
{
public:
	Eti(const wxString& title, const wxPoint& pos, const wxSize& size, double zoom, double zoomfactor, int computerType);
	~Eti();

	void configureComputer();
	void reDefineKeysA(int *, int *, int *);
	void reDefineKeysB(int *, int *, int *);
	void initComputer();
	void keyDown(int keycode);
	void keyUp(int keycode);

	Byte ef(int flag);
	Byte ef3();
	Byte in(Byte port, Word address);
	Byte inEti(Word address);
	void out(Byte port, Word address, Byte value);
	void outEti(Word address, Byte value);
	void cycle(int type);

	void startComputer();
	Byte readMem(Word addr);
	void writeMem(Word addr, Byte value, bool writeRom);
	void cpuInstruction();
	void onReset();
	void checkEtiFunction();
	void finishStopTape();
	void keyClear();

	Byte read1864ColorDirect(Word addr);
	void write1864ColorDirect(Word addr, Byte value);

private:
	bool eti660KeyState_[16];
	int cPressed;
	bool colorLatch_;
	Word ramMask_;

	int hexKeyDefA_[16];
	int keyDefGameHexA_[5];
	int keyDefGameValueA_[5];
	int keyDefGameHexB_[5];
	int keyDefGameValueB_[5];

	bool DataDirection_;
	Byte outputKeyLatch_;
	Byte inputKeyLatch_;
	Byte outputKeyValue_;
	Word endSave_;

	bool step_;
};

#endif  // ETI660_H
