/*
 *******************************************************************
 *** This software is copyright 2008 by Marcel van Tongeren      ***
 *** You have permission to use, modify, copy, and distribute    ***
 *** this software so long as this copyright notice is retained. ***
 *** This software may not be used in commercial applications    ***
 *** without express written permission from the author.         ***
 *******************************************************************
*/

#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

#include "main.h"
#include "functionkey.h"

#include "wx/xrc/xmlres.h"             

int keyUsed[] =
{// 0  1  2  3  4  5  6  7  8  9
	0, 0, 0, 0, 0, 0, 0, 0, 1, 1, // 0 - 9
	1, 0, 0, 1, 0, 0, 0, 0, 0, 0, // 10 - 19
	0, 0, 0, 0, 0, 0, 0, 1, 0, 0, // 20 - 29
	0, 0, 1, 1, 1, 1, 1, 1, 1, 0, // 30 - 39
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, // 40 - 49
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, // 50 - 59
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, // 60 - 69
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, // 70 - 79
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, // 80 - 89
	1, 1, 1, 1, 1, 1, 0, 1, 1, 1, // 90 - 99
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, // 100 - 109
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, // 110 - 119
	1, 1, 0, 0, 0, 0, 0, 1, 0, 0, // 120 - 129
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 130 - 139
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 140 - 149
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 150 - 159
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 160 - 169
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 170 - 179
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 180 - 189
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 190 - 199
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 200 - 209
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 210 - 219
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 220 - 229
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 230 - 239
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 240 - 249
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 250 - 259
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 260 - 269
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 270 - 279
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 280 - 289
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 290 - 299
	0, 0, 0, 0, 0, 0, 1, 1, 1, 0, // 300 - 309
	0, 1, 1, 1, 1, 1, 1, 1, 0, 0, // 310 - 319
	0, 1, 0, 1, 1, 1, 1, 1, 1, 1, // 320 - 329
	1, 1, 1, 0, 0, 0, 0, 0, 0, 0, // 330 - 339
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 340 - 349
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 350 - 359
	0, 0, 0, 0, 0, 1, 0, 0, 0, 0, // 360 - 369
	1, 0, 0, 0, 0, 0, 1, 1, 1, 1, // 370 - 379
	0, 0, 0, 0, 0, 0, 0, 1, 1, 0, // 380 - 389
	1, 1, 1, 0, 0, 0, 0, 0, 0, 0, // 390 - 399
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 400 - 409
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 410 - 419
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 420 - 429
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 430 - 439
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 440 - 449
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 450 - 459
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 460 - 469
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 470 - 479
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 480 - 489
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 490 - 499
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 500 - 509
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 510 - 519
};

BEGIN_EVENT_TABLE(FunctionKeyMapDialog, wxDialog)
   EVT_BUTTON(XRCID("Save"), FunctionKeyMapDialog::onSaveButton)
   EVT_BUTTON(XRCID("Default"), FunctionKeyMapDialog::onDefault)
   EVT_BUTTON(XRCID("FunctionKey0"), FunctionKeyMapDialog::onFunctionKey)
   EVT_BUTTON(XRCID("FunctionKey1"), FunctionKeyMapDialog::onFunctionKey)
   EVT_BUTTON(XRCID("FunctionKey2"), FunctionKeyMapDialog::onFunctionKey)
   EVT_BUTTON(XRCID("FunctionKey3"), FunctionKeyMapDialog::onFunctionKey)
   EVT_BUTTON(XRCID("FunctionKey4"), FunctionKeyMapDialog::onFunctionKey)
   EVT_BUTTON(XRCID("FunctionKey5"), FunctionKeyMapDialog::onFunctionKey)
   EVT_BUTTON(XRCID("FunctionKey6"), FunctionKeyMapDialog::onFunctionKey)
   EVT_BUTTON(XRCID("FunctionKey7"), FunctionKeyMapDialog::onFunctionKey)
   EVT_BUTTON(XRCID("FunctionKeyC"), FunctionKeyMapDialog::onFunctionKey)
   EVT_CHECKBOX(XRCID("EnableEscape"), FunctionKeyMapDialog::onEnableEscape)
END_EVENT_TABLE()

FunctionKeyMapDialog::FunctionKeyMapDialog(wxWindow* parent)
{
	wxXmlResource::Get()->Load(p_Main->getApplicationDir()+p_Main->getPathSep()+"functionkey.xrc");
	wxXmlResource::Get()->LoadDialog(this, parent, wxT("FunctionKeyDialog"));

	fKey_ = -1;

	XRCCTRL(*this, "Save", wxButton)->SetFocus();

	for (int i=0; i<13; i++)
		functionKey_[i] = p_Main->getFunctionKey(i);

	this->connectKeyDownEvent(this); 

	useExitKey_ = p_Main->getUseExitKey();
	XRCCTRL(*this, "EnableEscape", wxCheckBox)->SetValue(useExitKey_);
	XRCCTRL(*this, "FunctionKey0", wxButton)->Enable(useExitKey_);

	LoadAndCompare("Elf");
	LoadAndCompare("ElfII");
	LoadAndCompare("SuperElf");
	LoadAndCompare("Elf2K");
	LoadAndCompare("Cosmicos");
	LoadAndCompare("Eti");
	LoadAndCompare("TMC1800");
	LoadAndCompare("TMC2000");
	LoadAndCompare("Nano");
	LoadAndCompare("Vip");
	LoadAndCompareStudio("Studio2");
	LoadAndCompareStudio("Visicom");
	LoadAndCompareStudio("Victory");

	updateButtons();
}

void FunctionKeyMapDialog::LoadAndCompare(wxString computer)
{
	int hexKeyDef_[16];
	int keyDefGameValue_[5];
	int keyDefGameHex_[5];

	p_Main->getDefaultHexKeys(computer, "A", hexKeyDef_);
	for (int i=0; i<16; i++)
		keyUsed[hexKeyDef_[i]] = 1;
	p_Main->getDefaultHexKeys(computer, "B", hexKeyDef_);
	for (int i=0; i<16; i++)
		keyUsed[hexKeyDef_[i]] = 1;
	p_Main->getDefaultGameKeys(computer, "A", keyDefGameValue_, keyDefGameHex_);
	for (int i=0; i<5; i++)
		keyUsed[keyDefGameValue_[i]] = 1;
	p_Main->getDefaultGameKeys(computer, "B", keyDefGameValue_, keyDefGameHex_);
	for (int i=0; i<5; i++)
		keyUsed[keyDefGameValue_[i]] = 1;
}

void FunctionKeyMapDialog::LoadAndCompareStudio(wxString computerTypeStr_)
{
	int hexKeyDefB_[10];
	int hexKeyDefA_[10];

	hexKeyDefB_[0] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyB0", WXK_NUMPAD0);
	hexKeyDefB_[1] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyB1", WXK_NUMPAD7);
	hexKeyDefB_[2] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyB2", WXK_NUMPAD8);
	hexKeyDefB_[3] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyB3", WXK_NUMPAD9);
	hexKeyDefB_[4] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyB4", WXK_NUMPAD4);
	hexKeyDefB_[5] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyB5", WXK_NUMPAD5);
	hexKeyDefB_[6] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyB6", WXK_NUMPAD6);
	hexKeyDefB_[7] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyB7", WXK_NUMPAD1);
	hexKeyDefB_[8] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyB8", WXK_NUMPAD2);
	hexKeyDefB_[9] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyB9", WXK_NUMPAD3);

	hexKeyDefA_[0] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyA0", 88);
	hexKeyDefA_[1] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyA1", 49);
	hexKeyDefA_[2] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyA2", 50);
	hexKeyDefA_[3] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyA3", 51);
	hexKeyDefA_[4] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyA4", 81);
	hexKeyDefA_[5] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyA5", 87);
	hexKeyDefA_[6] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyA6", 69);
	hexKeyDefA_[7] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyA7", 65);
	hexKeyDefA_[8] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyA8", 83);
	hexKeyDefA_[9] = p_Main->getConfigItem(computerTypeStr_+"/HexKeyA9", 68);

	for (int i=0; i<10; i++)
		keyUsed[hexKeyDefA_[i]] = 1;
	for (int i=0; i<10; i++)
		keyUsed[hexKeyDefB_[i]] = 1;
}

void FunctionKeyMapDialog::compareButtons(int toBeCheckedButton, int toBeCheckedValue)
{
	wxString button;
	if (keyUsed[toBeCheckedValue] != 0)
	{
		button.Printf("FunctionKey%01X", toBeCheckedButton);
		XRCCTRL(*this, button, wxButton)->SetForegroundColour(wxColour(255,128,0));
	}
	for (int i=0; i<13; i++)
	{
		if (i != toBeCheckedButton && functionKey_[i] == toBeCheckedValue)
		{
			button.Printf("FunctionKey%01X", toBeCheckedButton);
			XRCCTRL(*this, button, wxButton)->SetForegroundColour(wxColour(255,0,0));
		}
	}
}

void FunctionKeyMapDialog::updateButtons()
{
	setLabel("FunctionKey%01X", 0, functionKey_[0]);
	compareButtons(0, functionKey_[0]);
	setLabel("FunctionKey%01X", 1, functionKey_[1]);
	compareButtons(1, functionKey_[1]);
	setLabel("FunctionKey%01X", 2, functionKey_[2]);
	compareButtons(2, functionKey_[2]);
	setLabel("FunctionKey%01X", 3, functionKey_[3]);
	compareButtons(3, functionKey_[3]);
	setLabel("FunctionKey%01X", 4, functionKey_[4]);
	compareButtons(4, functionKey_[4]);
	setLabel("FunctionKey%01X", 5, functionKey_[5]);
	compareButtons(5, functionKey_[5]);
	setLabel("FunctionKey%01X", 6, functionKey_[6]);
	compareButtons(6, functionKey_[6]);
	setLabel("FunctionKey%01X", 7, functionKey_[7]);
	compareButtons(7, functionKey_[7]);
	setLabel("FunctionKey%01X", 12, functionKey_[12]);
	compareButtons(12, functionKey_[12]);
}

void FunctionKeyMapDialog::onSaveButton( wxCommandEvent& WXUNUSED(event) )
{
	for (int i=0; i<13; i++)
		p_Main->setFunctionKey(i, functionKey_[i]);

	 p_Main->setUseExitKey(useExitKey_);

	EndModal( wxID_OK );
}

void FunctionKeyMapDialog::onFunctionKey(wxCommandEvent &event)
{
	wxString buttonName, buttonNumber;

	if (fKey_ != -1)
		setLabel("FunctionKey%01X", fKey_, functionKey_[fKey_]);

	buttonName = wxWindow::FindWindowById(event.GetId())->GetName();
	buttonNumber = buttonName.Last();
	if (buttonNumber.ToLong(&fKey_, 16))
		XRCCTRL(*this, buttonName, wxButton)->SetLabel("Press Key");
	else
		fKey_ = -1;
}

void FunctionKeyMapDialog::onDefault(wxCommandEvent& WXUNUSED(event))
{
	functionKey_[0] = WXK_ESCAPE;
	functionKey_[1] = WXK_F1;
	functionKey_[2] = WXK_F2;
	functionKey_[3] = WXK_F3;
	functionKey_[4] = WXK_F4;
	functionKey_[5] = WXK_F5;
	functionKey_[6] = WXK_F6;
#if defined(__WXGTK__)
	functionKey_[7] = WXK_MENU;
#else
	functionKey_[7] = WXK_WINDOWS_MENU;
#endif
	functionKey_[8] = WXK_F8;
	functionKey_[9] = WXK_F9;
	functionKey_[10] = WXK_F10;
	functionKey_[11] = WXK_F11;
	functionKey_[12] = WXK_F12;

	updateButtons();
	fKey_ = -1;
}

void FunctionKeyMapDialog::onKeyDown(wxKeyEvent& event)
{
	int key = event.GetKeyCode();
	if (key == WXK_SHIFT)
		return;

	if (fKey_ != -1)
	{
		setLabel("FunctionKey%01X", fKey_, key);
		functionKey_[fKey_] = key;
	}

	updateButtons();
}

void FunctionKeyMapDialog::connectKeyDownEvent(wxWindow* pclComponent) 
{ 
  if(pclComponent) 
  { 
    pclComponent->Connect(wxID_ANY, 
                          wxEVT_KEY_DOWN, 
                          wxKeyEventHandler(FunctionKeyMapDialog::onKeyDown), 
                          (wxObject*) NULL, 
                          this); 

    wxWindowListNode* pclNode = pclComponent->GetChildren().GetFirst(); 
    while(pclNode) 
    { 
      wxWindow* pclChild = pclNode->GetData(); 
      this->connectKeyDownEvent(pclChild); 
      
      pclNode = pclNode->GetNext(); 
    } 
  } 
} 

void FunctionKeyMapDialog::setLabel(wxString printStr, int button, int key)
{
	wxString keyStr, buttonStr;

	switch (key)
	{
		case WXK_NUMPAD0:
			keyStr.Printf("Pd 0 (%i)", key);
		break;

		case WXK_NUMPAD1:
			keyStr.Printf("Pd 1 (%i)", key);
		break;

		case WXK_NUMPAD2:
			keyStr.Printf("Pd 2 (%i)", key);
		break;

		case WXK_NUMPAD3:
			keyStr.Printf("Pd 3 (%i)", key);
		break;

		case WXK_NUMPAD4:
			keyStr.Printf("Pd 4 (%i)", key);
		break;

		case WXK_NUMPAD5:
			keyStr.Printf("Pd 5 (%i)", key);
		break;

		case WXK_NUMPAD6:
			keyStr.Printf("Pd 6 (%i)", key);
		break;

		case WXK_NUMPAD7:
			keyStr.Printf("Pd 7 (%i)", key);
		break;

		case WXK_NUMPAD8:
			keyStr.Printf("Pd 8 (%i)", key);
		break;

		case WXK_NUMPAD9:
			keyStr.Printf("Pd 9 (%i)", key);
		break;

		case WXK_BACK:
			keyStr.Printf("Back (%i)", key);
		break;

		case WXK_TAB:
			keyStr.Printf("Tab (%i)", key);
		break;

		case WXK_RETURN:
			keyStr.Printf("Return (%i)", key);
		break;

		case WXK_ESCAPE:
			keyStr.Printf("ESC (%i)", key);
		break;

		case WXK_DELETE:
			keyStr.Printf("Delete (%i)", key);
		break;

		case WXK_SHIFT:
			keyStr.Printf("Shift (%i)", key);
		break;

		case WXK_START:
 			keyStr.Printf("START (%i)", key);
		break;
		case WXK_LBUTTON:
 			keyStr.Printf("LButton (%i)", key);
		break;
		case WXK_RBUTTON:
 			keyStr.Printf("RButton (%i)", key);
		break;
		case WXK_CANCEL:
 			keyStr.Printf("Cancel (%i)", key);
		break;
		case WXK_MBUTTON:
 			keyStr.Printf("MButton (%i)", key);
		break;
		case WXK_CLEAR:
 			keyStr.Printf("Clear (%i)", key);
		break;
		case WXK_ALT:
 			keyStr.Printf("Alt (%i)", key);
		break;
		case WXK_CONTROL:
 			keyStr.Printf("Ctrl (%i)", key);
		break;
		case WXK_MENU:
 			keyStr.Printf("Menu (%i)", key);
		break;
  		case WXK_PAUSE:
 			keyStr.Printf("Pause (%i)", key);
		break;
  		case WXK_CAPITAL:
 			keyStr.Printf("Caps (%i)", key);
		break;
  		case WXK_END:
 			keyStr.Printf("End (%i)", key);
		break;
  		case WXK_HOME:
 			keyStr.Printf("Home (%i)", key);
		break;
  		case WXK_LEFT:
 			keyStr.Printf("Left (%i)", key);
		break;
  		case WXK_UP:
 			keyStr.Printf("Up (%i)", key);
		break;
  		case WXK_RIGHT:
 			keyStr.Printf("Right (%i)", key);
		break;
  		case WXK_DOWN:
 			keyStr.Printf("Down (%i)", key);
		break;
     	case WXK_SELECT:
 			keyStr.Printf("Select (%i)", key);
		break;
  		case WXK_PRINT:
 			keyStr.Printf("Print (%i)", key);
		break;
  		case WXK_EXECUTE:
 			keyStr.Printf("Exec (%i)", key);
		break;
  		case WXK_SNAPSHOT:
 			keyStr.Printf("Snap (%i)", key);
		break;
  		case WXK_INSERT:
 			keyStr.Printf("Ins (%i)", key);
		break;
  		case WXK_HELP:
 			keyStr.Printf("Help (%i)", key);
		break;
  		case WXK_MULTIPLY:
 			keyStr.Printf("* (%i)", key);
		break;
  		case WXK_ADD:
 			keyStr.Printf("+ (%i)", key);
		break;
  		case WXK_SEPARATOR:
 			keyStr.Printf("Sep (%i)", key);
		break;
  		case WXK_SUBTRACT:
 			keyStr.Printf("- (%i)", key);
		break;
  		case WXK_DECIMAL:
 			keyStr.Printf(", (%i)", key);
		break;
  		case WXK_DIVIDE:
 			keyStr.Printf("/ (%i)", key);
		break;
  		case WXK_F1:
 			keyStr.Printf("F1 (%i)", key);
		break;
  		case WXK_F2:
 			keyStr.Printf("F2 (%i)", key);
		break;
  		case WXK_F3:
 			keyStr.Printf("F3 (%i)", key);
		break;
  		case WXK_F4:
 			keyStr.Printf("F4 (%i)", key);
		break;
  		case WXK_F5:
 			keyStr.Printf("F5 (%i)", key);
		break;
  		case WXK_F6:
 			keyStr.Printf("F6 (%i)", key);
		break;
   		case WXK_F7:
 			keyStr.Printf("F7 (%i)", key);
		break;
  		case WXK_F8:
 			keyStr.Printf("F8 (%i)", key);
		break;
  		case WXK_F9:
 			keyStr.Printf("F9 (%i)", key);
		break;
  		case WXK_F10:
 			keyStr.Printf("F10 (%i)", key);
		break;
  		case WXK_F11:
 			keyStr.Printf("F11 (%i)", key);
		break;
  		case WXK_F12:
 			keyStr.Printf("F12 (%i)", key);
		break;
  		case WXK_F13:
 			keyStr.Printf("F13 (%i)", key);
		break;
  		case WXK_F14:
 			keyStr.Printf("F14 (%i)", key);
		break;
  		case WXK_F15:
 			keyStr.Printf("F15 (%i)", key);
		break;
  		case WXK_F16:
 			keyStr.Printf("F16 (%i)", key);
		break;
  		case WXK_F17:
 			keyStr.Printf("F17 (%i)", key);
		break;
  		case WXK_F18:
 			keyStr.Printf("F18 (%i)", key);
		break;
  		case WXK_F19:
 			keyStr.Printf("F19 (%i)", key);
		break;
  		case WXK_F20:
 			keyStr.Printf("F20 (%i)", key);
		break;
  		case WXK_F21:
 			keyStr.Printf("F21 (%i)", key);
		break;
  		case WXK_F22:
 			keyStr.Printf("F22 (%i)", key);
		break;
  		case WXK_F23:
 			keyStr.Printf("F23 (%i)", key);
		break;
  		case WXK_F24:
 			keyStr.Printf("F24 (%i)", key);
		break;
  		case WXK_NUMLOCK:
 			keyStr.Printf("NumLock (%i)", key);
		break;
  		case WXK_SCROLL:
 			keyStr.Printf("Scroll (%i)", key);
		break;
  		case WXK_PAGEUP:
 			keyStr.Printf("PgUp (%i)", key);
		break;
  		case WXK_PAGEDOWN:
 			keyStr.Printf("PgDn (%i)", key);
		break;
  		case WXK_NUMPAD_SPACE:
 			keyStr.Printf("Pd space (%i)", key);
		break;
  		case WXK_NUMPAD_TAB:
 			keyStr.Printf("Pd tab (%i)", key);
		break;
   		case WXK_NUMPAD_ENTER:
 			keyStr.Printf("Enter (%i)", key);
		break;
   		case WXK_NUMPAD_F1:
 			keyStr.Printf("Pd F1 (%i)", key);
		break;
   		case WXK_NUMPAD_F2:
 			keyStr.Printf("Pd F2 (%i)", key);
		break;
   		case WXK_NUMPAD_F3:
 			keyStr.Printf("Pd F3 (%i)", key);
		break;
   		case WXK_NUMPAD_F4:
 			keyStr.Printf("Pd F4 (%i)", key);
		break;
    	case WXK_NUMPAD_HOME:
 			keyStr.Printf("Pd Home (%i)", key);
		break;
    	case WXK_NUMPAD_LEFT:
 			keyStr.Printf("Pd Left (%i)", key);
		break;
    	case WXK_NUMPAD_UP:
 			keyStr.Printf("Pd Up (%i)", key);
		break;
    	case WXK_NUMPAD_RIGHT:
 			keyStr.Printf("Pd Right (%i)", key);
		break;
    	case WXK_NUMPAD_DOWN:
 			keyStr.Printf("Pd Dwn (%i)", key);
		break;
    	case WXK_NUMPAD_PAGEUP:
 			keyStr.Printf("Pd PgUp (%i)", key);
		break;
    	case WXK_NUMPAD_PAGEDOWN:
 			keyStr.Printf("Pd PgDn (%i)", key);
		break;
    	case WXK_NUMPAD_END:
 			keyStr.Printf("Pd End (%i)", key);
		break;
    	case WXK_NUMPAD_BEGIN:
 			keyStr.Printf("Pd Bgn (%i)", key);
		break;
    	case WXK_NUMPAD_INSERT:
 			keyStr.Printf("Pd Ins (%i)", key);
		break;
    	case WXK_NUMPAD_DELETE:
 			keyStr.Printf("Pd Del (%i)", key);
		break;
    	case WXK_NUMPAD_EQUAL:
 			keyStr.Printf("Pd = (%i)", key);
		break;
    	case WXK_NUMPAD_MULTIPLY:
 			keyStr.Printf("Pd * (%i)", key);
		break;
    	case WXK_NUMPAD_ADD:
 			keyStr.Printf("Pd + (%i)", key);
		break;
    	case WXK_NUMPAD_SEPARATOR:
 			keyStr.Printf("Pd Sep (%i)", key);
		break;
    	case WXK_NUMPAD_SUBTRACT:
 			keyStr.Printf("Pd - (%i)", key);
		break;
    	case WXK_NUMPAD_DECIMAL:
 			keyStr.Printf("Pd , (%i)", key);
		break;
    	case WXK_NUMPAD_DIVIDE:
 			keyStr.Printf("Pd / (%i)", key);
		break;
    	case WXK_WINDOWS_LEFT:
 			keyStr.Printf("Win Left (%i)", key);
		break;
    	case WXK_WINDOWS_RIGHT:
 			keyStr.Printf("Win Right (%i)", key);
		break;
    	case WXK_WINDOWS_MENU:
 			keyStr.Printf("Menu (%i)", key);
		break;
		default:
			keyStr.Printf("%c (%i)", key, key);
		break;
	}
	if (button < 16)
		buttonStr.Printf(printStr, button);
	else
		buttonStr = printStr;
	XRCCTRL(*this, buttonStr, wxButton)->SetLabel(keyStr);
	XRCCTRL(*this, buttonStr, wxButton)->SetForegroundColour(wxNullColour);
}

void FunctionKeyMapDialog::onEnableEscape(wxCommandEvent&event)
{
	useExitKey_ = event.IsChecked();
	XRCCTRL(*this, "FunctionKey0", wxButton)->Enable(useExitKey_);
}
