#ifndef GUIVIP_H
#define GUIVIP_H

#include "guitmc2000.h"

class GuiVip: public GuiTMC2000
{
public:

	GuiVip(const wxString& title, const wxPoint& pos, const wxSize& size, Mode mode_, wxString dataDir);
	~GuiVip() {};

	void readVipConfig();
	void writeVipConfig();


	void onTempo(wxScrollEvent&event);
	void onSound(wxCommandEvent&event);
	void onRamSWVip(wxCommandEvent&event);
	void onRamSWText(wxCommandEvent&event);
	void onVipRam(wxSpinEvent& event);
	void onVipVp570(wxSpinEvent& event);
	void onVipVp580(wxCommandEvent& event);
	void onVipVp590(wxCommandEvent& event);
	void onVipHighRes(wxCommandEvent&event);
	void onVipStereo(wxCommandEvent&event);

	void setSoundGui(int sound);
	int getVipVp570() {return vipVp570_;};
	bool getVipVp580() {return vipVp580_;};
	bool getVipVp590() {return vipVp590_;}; 
	int getVipStereo() {return stereo_;};
	int getVipHighRes() {return highRes_;};

private:
	int vipVp570_;
	bool vipVp580_;
	bool vipVp590_;
	bool highRes_;
	bool stereo_;

	DECLARE_EVENT_TABLE()
};

#endif // GUIVIP_H
