#ifndef PIXIE_H
#define PIXIE_H

#include "video.h"

class PlotList
{
public: 
	wxCoord x;
	wxCoord y;
	PlotList *nextPlot;
};

class Pixie : public Video
{
public:

	Pixie(const wxString& title, const wxPoint& pos, const wxSize& size, double zoom, double zoomfactor, int computerType);
	~Pixie();

	void reset();
	void configurePixie();
	void configurePixieStudio2();
	void configurePixieVisicom();
	void configurePixieVip();
	void configurePixieTmc1800();
	void configurePixieTelmac();
	void configurePixieVictory();
	void configurePixieEti();
	void initiateColour(bool colour);
	void configurePixieNano();
	void configurePixieCosmicos();
	void initPixie(); 
	Byte efPixie();
	Byte inPixie();
	void outPixie(); 
	void outPixieBackGround(); 
	void cyclePixie(); 
	void cyclePixieTelmac(); 

	void copyScreen();
	void drawScreen();
	void plot(int x, int y, int c, int color);

	void setFullScreen(bool fullScreenSet);
	void onF3();

private:
	PlotList *plotListPointer;
	wxString runningComputer_;

	int computerType_;
	Byte pbacking_[128][192];
	Byte color_[128][192];
	Byte vidInt_;
	Byte vidCycle_;

	bool graphicsOn_;
	long graphicsMode_;
	long graphicsNext_;
	int graphicsX_;
	Byte pixieEf_;

	int backGroundInit_;

	int updatePlot_;
	int colourMask_;
	int highRes_;
};

#endif  // PIXIE_H
