#ifndef VIP_H
#define VIP_H

#include "cdp1802.h"
#include "pixie.h"
#include "keyboard.h"

class Vip : public Cdp1802, public Pixie
{
public:
	Vip(const wxString& title, const wxPoint& pos, const wxSize& size, double zoom, double zoomfactor, int computerType, double clock, int tempo);
	~Vip();

	void configureComputer();
	void configureKeyboard();
	void initComputer();
	void charEvent(int keycode);
	void keyDown(int keycode);
	void keyUp(int keycode);

	void onRun();

	Byte ef(int flag);
	Byte ef3();
	Byte ef4();
	Byte in(Byte port, Word address);
	void out(Byte port, Word address, Byte value);
	void outVip(Byte value);
	void switchQ(int value);
	void cycle(int type);
	void cycleVP550();

	void startComputer();
	void setTempo(int tempo);
	Byte readMem(Word addr);
	void writeMem(Word addr, Byte value, bool writeRom);
	void cpuInstruction();
	void onReset();
	void checkVipFunction();
	void sleepComputer(long ms);

	Byte read1864ColorDirect(Word addr);
	void write1864ColorDirect(Word addr, Byte value);
	void defineKeys();
	void reDefineKeysA(int *, int *, int *);
	void reDefineKeysB(int *, int *, int *);

private:
	Byte vipKeyPort_;
	Byte vipKeyState_[2][16];
	bool runPressed_;
	Word addressLatch_;

	bool cdp1862_;
	bool vp580_;
	bool vp550IntOn_;
	Word ramMask_;

	int hexKeyDefA_[16];
	int keyDefGameHexA_[5];
	int keyDefGameValueA_[5];

	int hexKeyDefB_[16];
	int keyDefGameHexB_[5];
	int keyDefGameValueB_[5];

	int cycleValue_;
	int cycleSize_;
	int colourMask_;
	bool useKeyboard_;
	bool redefineKeys_;

	char keyboardValue_;
	Byte keyboardEf_;
	Byte printLatch_;
	int stateQ_;
	bool usePrinter_;
	bool player2defined_;

	KeyDef keyDefinition[512];
};

#endif  // VIP_H
